freeslot("sfx_orngdm", "sfx_orngdl", "sfx_orngdd", "SKINCOLOR_ORANGEDEMON", "SKINCOLOR_ORANGELUIGIDEMON")

sfxinfo[sfx_orngdm].caption = "Orange Demon Activate"
sfxinfo[sfx_orngdl].caption = "Orange Demon Activate"
sfxinfo[sfx_orngdd].caption = "Orange Demon Death"

--Properties an entry can have:
  --startsound: The sound to play on level start when this demon is present
  --color: The color this demon should be colorized with
  --deathsound: The sound to play when this demon dies
if not(orangedemondata) then
	rawset(_G, "orangedemonmeta", {})
end

if not orangedemonmeta.luigi then
	orangedemonmeta.luigi = {
		startsound = sfx_orngdl,
		color = SKINCOLOR_ORANGELUIGIDEMON
	}
end

skincolors[SKINCOLOR_ORANGEDEMON] = {
    name = "OrangeDemon",
    ramp = {30, 29, 47, 46, 71, 45, 63, 62, 42, 60, 59, 58, 57, 56, 35, 33},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_ORANGEMAP,
    accessible = false
}

skincolors[SKINCOLOR_ORANGELUIGIDEMON] = {
    name = "OrangeLuigiDemon",
    ramp = {31, 30, 110, 119, 118, 117, 117, 116, 102, 101, 100, 99, 98, 130, 129, 128},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_ORANGEMAP,
    accessible = false
}

addHook("PlayerThink",
--[[@param p player_t]]
function (p)
    if p.bot then
        local exiting = p.botleader and (p.botleader.pflags & PF_FINISHED or p.botleader.exiting)
        if not p.mo.orangedemon and not exiting then
            p.mo.orangedemon = {
                delayTill = leveltime + TICRATE*2,
                cured = false
            }
            if orangedemonmeta[p.mo.skin] then
                p.mo.color = orangememonmeta[p.mo.skin].color or SKINCOLOR_ORANGEDEMON
            else
                p.mo.color = SKINCOLOR_ORANGEDEMON
            end
            p.mo.colorized = true
        end
		if not p.mo.orangedemon then return end
        if leveltime == 0 and not p.mo.laughed then
            p.mo.laughed = true
            local sfx
            if orangedemonmeta[p.mo.skin] then
                sfx = orangedemonmeta[p.mo.skin].startsound or sfx_orngdm
            else
                sfx = sfx_orngdm
            end
            S_StartSound(p.mo, sfx, p.botleader)
        end
        if leveltime < p.mo.orangedemon.delayTill then
            p.pflags = $ | PF_FULLSTASIS
        else
            p.pflags = $ & ~PF_FULLSTASIS
            p.mo.flags = $ | MF_SPECIAL
        end
        if p.botleader then
            if exiting and not p.mo.orangedemon.cured then
                p.mo.orangedemon.cured = true
                local deathObj = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_PLAYER)
                deathObj.skin = p.mo.skin
                deathObj.color = p.mo.color
                deathObj.colorized = true
                deathObj.demondeath = true
                p.mo.color = p.skincolor
                p.mo.colorized = false
                deathObj.fuse = TICRATE*3
                deathObj.state = S_PLAY_DEAD
                deathObj.flags = MF_NOCLIPHEIGHT | MF_NOCLIP | MF_SOLID
				local sfx
				if orangedemonmeta[p.mo.skin] then
					sfx = orangedemonmeta[p.mo.skin].deathsound or sfx_orngdd
				else
					sfx = sfx_orngdd
				end
				S_StartSound(deathObj, sfx, p.botleader)
                --P_KillMobj(deathObj)

                deathObj.fmomz = 0
                deathObj.z = p.mo.z + FRACUNIT
            end
            p.powers[pw_sneakers] = p.botleader.powers[pw_sneakers]
        end
    end
end)

addHook("MobjThinker",
--[[@param mo mobj_t]]
function (mo)
    if mo.demondeath then
        mo.momz = mo.fmomz
        mo.fmomz = $ + 7*FRACUNIT/8
        mo.z = $ + mo.momz
        mo.spritexscale = 79*$ / 80
        mo.spriteyscale = 80*$ / 79
        mo.frame = $ | FF_TRANS20
    end
end, MT_PLAYER)

addHook("TouchSpecial",
--[[@param special mobj_t]]
--[[@param toucher mobj_t]]
function(special, toucher)
    if special.orangedemon and not special.orangedemon.cured then
        if toucher.valid and toucher.player and not toucher.orangedemon
        and special.orangedemon.delayTill < leveltime then
            if special.player.powers[pw_flashing] or special.state == S_PLAY_PAIN or special.state == S_PLAY_DEAD then return end
            if toucher.player.powers[pw_shield] ~= SH_NONE then
                P_DamageMobj(toucher, special)
                P_DamageMobj(special, toucher)
            else
                P_KillMobj(toucher, special)
            end
        end
    end
    return true
end, MT_PLAYER)

addHook("MobjThinker", function (mo)
    if mo.tracer.orangedemon then
        mo.color = mo.tracer.color
        mo.colorized = true
    end
end, MT_TAILSOVERLAY)

addHook("ShouldDamage",
--[[@param target mobj_t]]
--[[@param inflictor mobj_t]]
--[[@param source mobj_t]]
function (target, inflictor, source, damage, damagetype)
    if not source then return end
    if target.orangedemon and source.type ~= MT_PLAYER then return false end
    if source.orangedemon and target.type ~= MT_PLAYER then return false end
end)